;+
; NAME:
;	Modify Titles
; PURPOSE:
;	Changes title definitions, tick mark names, inteval
;	between ticks, number of tickmarks, style and
;	type of plot and plotting symbol.
; CATEGORY:
;	User interface
; CALLING SEQUENCE:
;	Modif_Titles
; SIDE EFFECTS
;	The value of some system variables are changed, dependent
;	on the option chosen.
; 	Menus are used. On vt300 terminals, the
;	display is erased
;-
; MODIFICATION HISTORY:
;	Created in June 1991 by A.Csillaghy

PRO TicksChange, menuT, nr, tickName
 
tempStr = ''
IF StrLen(tickName(0) ) EQ 0 THEN $
  menuT(nr) = StrMid(menuT(nr),0,24) + 'System Defined' $
ELSE BEGIN
  i = 0 
  WHILE (tickName(i) NE '') AND (i  LT 29 ) DO BEGIN
    tempStr = tempStr + tickName(i) + ' '
    IF i LT 29 THEN i = i+1 
  ENDWHILE
ENDELSE 
menuT(nr) = StrMid(menuT(nr),0,24) + tempStr

END


PRO Intervals, menuT, nr, ticksInt

IF ticksInt EQ 0 THEN menuT(nr) = StrMid(menuT(nr),0,43) $
	 + 'System Defined' $
ELSE menuT(nr) = StrMid(menuT(nr),0,43) + StrTrim(ticksInt,2)

END


PRO MinorTicksNr, menuT, nr, minorNr

IF minorNr EQ 0 THEN $
	menuT(nr) = StrMid(menuT(nr),0,27) + 'System Defined' $
ELSE IF minorNr EQ -1 THEN $
	menuT(nr) = StrMid(menuT(nr),0,27)+'none' $
ELSE menuT(nr) = StrMid(menuT(nr),0,27) + StrTrim(minorNr,2)

END



PRO ModifTickDef, dir

i=0
PTo, 5,5,'Please give the new names of the '+dir+' tickmarks.'
Print,'They must be maximal 30.'
Print,'Type <return> to stop.'
Print,'Typing <return> for the first tick name will set the system ticks'
REPEAT BEGIN
  tickName  = ''
  Read,'Tick Name '+StrTrim(i+1,2)+': ', tickName
  IF dir EQ 'X' THEN  !x.tickname(i) = tickName $
  ELSE !y.tickname(i)  = tickName
  i = i+1
END UNTIL i EQ 30 OR StrLen(tickName) EQ 0
IF i EQ 1 THEN $
  IF dir EQ 'X' THEN  !x.tickname= '' $
  ELSE !y.tickname = ''

END


PRO ModifInterval, dir

PTo, 18,5,'Please insert the new interval between major '+ $
	dir+' tick marks. '
Print,'Type 0 for system definition'
Read,'Number of intervals:',interval
IF dir EQ 'X' THEN !x.ticks = interval ELSE !y.ticks = interval

END

PRO ModifMarksNr, dir

PTo,18,5,'Please insert the new number of minor '+dir+' tick marks.'
Print,'Type -1 for system definition.'
Print,'Type 0 for no ticks.'
Read,'Number of minor tick marks: ',minor
IF dir EQ 'X' THEN !x.minor = minor+1 ELSE !y.minor = minor+1

END


PRO ModifXYZTitle, dir

  title = ''
  Read,' Please give the new '+ dir +' title: ', title
  CASE dir OF
    'X': !x.title = title 
    'Y': !y.title = title
    'Z': !z.title = title
  ELSE:
  ENDCASE

END

PRO Modif_Titles


mainMenuLength = 13
mainMenu = StrArr(mainMenuLength)

mainMenu(0) = 'Main Title: '+ !p.title 
mainMenu(1) = 'Subtitle: ' + !p.subtitle
mainMenu(2) = 'X Title: '+ !x.title
mainMenu(3) = 'Y Title: ' + !y.title
mainMenu(4) = 'Z Title: '+ !z.title
mainMenu(5) = 'X Tickmarks Definition: '
mainMenu(6) = 'Y Tickmarks Definition: '
mainMenu(7) = 'Number of Intervals Between X Major Ticks: '
mainMenu(8) = 'Number of Intervals Between Y Major Ticks: '
mainMenu(9) = 'X Minor Tick Marks Number: '
mainMenu(10) = 'Y Minor Tick Marks Number: '
mainMenu(12) = 'Return to Main Customize Menu '


TicksChange, mainMenu, 5, !x.tickname
TicksChange, mainMenu, 6, !y.tickname

Intervals, mainMenu, 7, !x.ticks
Intervals, mainMenu, 8, !y.ticks

MinorTicksNr, mainMenu, 9, !x.minor
MinorTicksNr, mainMenu, 10, !y.minor

IF !p.font EQ 0 THEN mainMenu(11) = 'Hardware Font' $
ELSE mainMenu(11) = 'Software Font, size '+StrTrim(!p.charsize,2)

REPEAT BEGIN
  Clear_Screen
  choice = General_Menu( mainMenu, $
	' Choose Attribute to Change')
  str = ''
  CASE choice OF
    1: BEGIN
          Read,'Please give the new title: ', str
          !p.title = str
          mainMenu(0) = StrMid(mainMenu(0),0,12) + str
        END
    2: BEGIN
          Read,'Please give the new subtitle: ', str
          !p.subtitle = str
          mainMenu(1) = StrMid(mainMenu(1),0,10)+str
         END
    3: BEGIN
          ModifXYZTitle, 'X'
          mainMenu(2) = StrMid(mainMenu(2),0,9)+ !x.title
        END
    4: BEGIN
          ModifXYZTitle, 'Y'
          mainMenu(3) = StrMid(mainMenu(3),0,9)+!y.title
        END
    5: BEGIN
          ModifXYZTitle, 'Z'
          mainMenu(4) = StrMid(mainMenu(4),0,9)+!z.title
        END
    6: BEGIN
          ModifTickDef, 'X'
          TicksChange,mainMenu,5,!x.tickname
        END
    7: BEGIN
          ModifTickDef, 'Y'
          TicksChange,mainMenu,6,!y.tickname
        END
    8: BEGIN
          ModifInterval, 'X'
          Intervals, mainMenu, 7, !x.ticks
         END
    9: BEGIN
          ModifInterval, 'Y'
          Intervals, mainMenu, 8, !y.ticks
         END
    10: BEGIN
          ModifMarksNr, 'X'
          MinorTicksNr, mainMenu, 9, !x.minor
        END
    11: BEGIN
            ModifMarksNr, 'Y'
            MinorTicksNr, mainMenu, 10, !y.minor
          END
     12: BEGIN
              IF !p.font EQ 0 THEN BEGIN
                Read_Test,'Please enter the character size ',1,charsize
                mainMenu(11) = 'Software Font, size '+StrTrim(charsize,2)
                !p.charsize = charsize
                !p.font = -1
              ENDIF ELSE BEGIN
                mainMenu(11) = 'Hardware Font'
                !p.font = 0
              ENDELSE
           END
      ELSE:
  ENDCASE
END UNTIL choice EQ mainMenuLength

END       
          




