PRO Symbols, currSym, INTERACTIVE = interactive

;+
; NAME
;	Symbols
; PURPOSE:
;	To change interactively the symbol used to plot,
;	and get its name in a string variable
; CATEGORY:
;	User interface
; CALLING SEQUENCE
;	Symbols [, currSym]
; OUTPUT PARAMETER:
;	currSym: name of the symbol chosen
; KEYWORD:
;	/INTERACTIVE: if set, the symbol can be
;		chosen from a list presented in a menu form. 
;		If not set, returns the current symbol name.
; SIDE EFFECTS:
;	In interactive mode, changes the value of the system
;	variable !psym
; 	Use menu and terminal in x - windows, erases
;	the display in vt300 terminals.
;- 
; MODIFICATION HISTORY:
;	Created in June 1991, A.Csillaghy

menuLength = 12
menuSym= StrArr(menuLength)

IF !psym LE 0 THEN lineMode = 'On' ELSE lineMode = 'Off'
menuSym(0)='Line Mode '+lineMode
menuSym(1)='Plus Sign +'
menuSym(2)='Asterisk *'
menuSym(3)='Period .'
menuSym(4)='Diamond'
menuSym(5)='Triangle'
menuSym(6)='Square'
menuSym(7)='X'
menuSym(8)='Histogram Mode'
menuSym(9)='Numbers'
menuSym(10)='No Symbols'
menuSym(11)='Return to Main Menu'

choice = 0

REPEAT BEGIN
 
  symbol = ABS(!psym)
  IF (symbol LE 8) AND (symbol GT 0) THEN $
	currSym = menuSym(symbol) $
  ELSE IF symbol EQ 0 THEN currSym = 'none' $
  ELSE IF symbol EQ 10 THEN currSym = 'histogram' $
  ELSE IF (symbol GE 11) AND (symbol LE 19) THEN $
	currSym = STRING(symbol-10)

  IF Keyword_Set(INTERACTIVE) THEN BEGIN
    Clear_Screen
    PTo,menuLength+5,1,'Current symbol is '+currSym
    PTo,menuLength+6,1,'Line mode is '+lineMode
    choice = General_Menu(menuSym, $
	'Choose the New Symbol or Line Mode')
    choice = choice -1
    IF (0 LT Abs(choice)) AND (Abs(choice) LT 9) THEN $
      IF !psym EQ 0 THEN !psym = choice ELSE $
        !psym = choice*!psym / ABS( !psym )  $
    ELSE CASE choice OF
      0: BEGIN
           !psym = -!psym
           IF !psym LE 0 THEN lineMode = 'On' ELSE lineMode = 'Off'
           menuSym(0) = 'Line Mode '+lineMode
         END
      9: BEGIN
           PTo,menuLength+8,1,'Choose the number: '
           Read,number
           !psym = (number+10)*(1-2*(!psym LT 0))
         END
      10: !psym = 0
    ELSE:
    END
  ENDIF ELSE RETURN

END UNTIL choice EQ menuLength-1

RETURN
END

