; NAME:
;	Titles_Display
; PURPOSE:
;	Changes title definitions, tick mark names, inteval
;	between ticks, number of tickmarks, style and
;	type of plot and plotting symbol.
; CATEGORY:
;	User interface
; CALLING SEQUENCE:
;	Titles_Display
; SIDE EFFECTS
;	The value of some system variables are changed, dependent
;	on the option chosen.
; 	Menus are used. On vt300 terminals, the
;	display is erased
;-
; MODIFICATION HISTORY:
;	Created in June 1991 by A.Csillaghy

      
PRO TicksChange, menuT, nr, tickName
 
tempStr = ''
IF StrLen(tickName(0) ) EQ 0 THEN $
  menuT(nr) = StrMid(menuT(nr),0,24) + 'System Defined' $
ELSE BEGIN
  i = 0 
  WHILE (tickName(i) NE '') AND (i  LT 29 ) DO BEGIN
    tempStr = tempStr + tickName(i) + ' '
    IF i LT 29 THEN i = i+1 
  ENDWHILE
ENDELSE 
menuT(nr) = StrMid(menuT(nr),0,24) + tempStr

END


PRO Intervals, menuT, nr, ticksInt

IF ticksInt EQ 0 THEN menuT(nr) = StrMid(menuT(nr),0,43) $
	 + 'System Defined' $
ELSE menuT(nr) = StrMid(menuT(nr),0,43) + StrTrim(ticksInt,2)

END


PRO MinorTicksNr, menuT, nr, minorNr

IF minorNr EQ 0 THEN $
	menuT(nr) = StrMid(menuT(nr),0,27) + 'System Defined' $
ELSE IF minorNr EQ -1 THEN $
	menuT(nr) = StrMid(menuT(nr),0,27)+'none' $
ELSE menuT(nr) = StrMid(menuT(nr),0,27) + StrTrim(minorNr-1,2)

END


PRO AxisStyle, menuT, nr, value

text = ''
IF (value AND 1B) EQ 1 THEN text = 'Exact'
IF (value AND 2B) EQ 2 THEN  text = text + ' Extended'
IF (value AND 4B) EQ 4 THEN text = text + ' None'
IF (value AND 8B) EQ 8 THEN text = text + ' No Box'

IF text EQ '' THEN $
	menuT(nr) = StrMid(menuT(nr),0,14)+'System Standard' $
ELSE menuT(nr) = StrMid(menuT(nr),0, 14) + text

END


PRO  AxisType, menuT, nr, value

IF value EQ 0 THEN menuT(nr) = StrMid(menuT(nr),0,13)+'Linear' $
ELSE menuT(nr) = StrMid(menuT(nr),0,13)+'Logaritmic'

END


PRO ModifXYTitle, dir

  title = ''
  Read,' Please give the new '+ dir +' title: ', title
  IF dir EQ 'X' THEN !x.title = title ELSE !y.title = title

END


PRO ModifTickDef, dir

i=0
PTo, 5,5,'Please give the new names of the '+dir+' tickmarks.'
Print,'They must be maximal 30.'
Print,'Type <return> to stop.'
Print,'Typing <return> for the first tick name will set the system ticks'
REPEAT BEGIN
  tickName  = ''
  Read,'Tick Name '+StrTrim(i+1,2)+': ', tickName
  IF dir EQ 'X' THEN  !x.tickname(i) = tickName $
  ELSE !y.tickname(i)  = tickName
  i = i+1
END UNTIL i EQ 30 OR StrLen(tickName) EQ 0
IF i EQ 1 THEN $
  IF dir EQ 'X' THEN  !x.tickname= '' $
  ELSE !y.tickname = ''

END


PRO ModifInterval, dir

  PTo, 18,5,'Please insert the new interval between major '+ $
	dir+' tick marks. '
  Print,'Type 0 for system definition'
  const = !x.ticks*( dir EQ 'X' ) + !y.ticks*( dir NE 'X' )
  Read_Test, 'Number of intervals:',const,interval
  IF dir EQ 'X' THEN !x.ticks = interval < 29 > 0 $
  ELSE !y.ticks = interval < 29 > 0

END ; Modif Interval

PRO ModifMarksNr, dir

  PTo,18,5,'Please insert the new number of minor '+dir+' tick marks.'
  Print,'Type -1 for system definition.'
  Print,'Type 0 for no ticks.'
  Read,'Number of minor tick marks: ',minor
  IF dir EQ 'X' THEN !x.minor = minor+1 ELSE !y.minor = minor+1

END ; modif marks nr







PRO ModifStyle, dir

  choice = General_Menu(['Exact', 'Extended', 'None', 'No Box', $
	'System Style'],  $
 	'Choose the style of '+dir+ ' axis')
  IF choice LT 5 THEN $
    IF dir EQ 'X' THEN !x.style = !x.style OR BYTE(2^(choice-1)) $
    ELSE !y.style = !y.style OR BYTE(2^(choice-1)) $
  ELSE $
    IF dir EQ 'X' THEN !x.style = 0 $
    ELSE !y.style = 0

END


PRO LineStyle, menu, index, ls

text = menu(index)
text = StrMid(text,0,12)
CASE ls OF
  0: text = text + 'Solid'
  1: text = text + 'Dotted'
  2: text = text + 'Dashed'
  3: text = text + 'Dash Dot'
  4: text = text + 'Dash Dot Dot Dot'
  5: text = text + 'Long Dashes'
ENDCASE

menu(index) = text

END


PRO Titles_Display

mainMenuLength = 19
mainMenu = StrArr(mainMenuLength)

mainMenu(0) = 'Main Title: '+ !p.title 
mainMenu(1) = 'Subtitle: ' + !p.subtitle
mainMenu(2) = 'X Title: '+ !x.title
mainMenu(3) = 'Y Title: ' + !y.title
mainMenu(4) = 'X Tickmarks Definition: '
mainMenu(5) = 'Y Tickmarks Definition: '
mainMenu(6) = 'Number of Intervals Between X Major Ticks: '
mainMenu(7) = 'Number of Intervals Between Y Major Ticks: '
mainMenu(8) = 'X Minor Tick Marks Number: '
mainMenu(9) = 'Y Minor Tick Marks Number: '
mainMenu(10) = 'X Axis Style: '
mainMenu(11) = 'Y Axis Style: '
mainMenu(12) = 'X Axis Type: '
mainMenu(13) = 'Y Axis Type: '
mainMenu(14) = 'Plotting Symbol Used: '
mainMenu(16) = 'Line Style: '
mainMenu(17) = ''
mainMenu(18) = 'Return to Main Customize Menu '


TicksChange, mainMenu, 4, !x.tickname
TicksChange, mainMenu, 5, !y.tickname

Intervals, mainMenu, 6, !x.ticks
Intervals, mainMenu, 7, !y.ticks

MinorTicksNr, mainMenu, 8, !x.minor
MinorTicksNr, mainMenu, 9, !y.minor

AxisStyle, mainMenu, 10, !x.style
AxisStyle, mainMenu, 11, !y.style

AxisType, mainMenu, 12, !x.type
AxisType, mainMenu, 13, !y.type

Symbols, sName
mainMenu(14) = StrMid( mainMenu(14), 0, 22 ) + sName

IF !p.font EQ 0 THEN mainMenu(15) = 'Hardware Font' $
ELSE IF !p.charsize NE 0 THEN $
	mainMenu(15) = 'Software Font, size '+ $
		StrTrim(!p.charsize,2) $
ELSE mainMenu(15) = 'Software  Font, System Defined'

LineStyle, mainMenu, 16, !p.linestyle

REPEAT BEGIN
  Clear_Screen
  choice = General_Menu( mainMenu, $
	' Choose Attribute to Change')
  str = ''
  CASE choice OF
    1: BEGIN
          Read,'Please give the new title: ', str
          !p.title = str
          mainMenu(0) = StrMid(mainMenu(0),0,12) + str
        END
    2: BEGIN
          Read,'Please give the new subtitle: ', str
          !p.subtitle = str
          mainMenu(1) = StrMid(mainMenu(1),0,10)+str
         END
    3: BEGIN
          ModifXYTitle, 'X'
          mainMenu(2) = StrMid(mainMenu(2),0,9)+ !x.title
        END
    4: BEGIN
          ModifXYTitle, 'Y'
          mainMenu(3) = StrMid(mainMenu(3),0,9)+!y.title
        END
    5: BEGIN
          ModifTickDef, 'X'
          TicksChange,mainMenu,4,!x.tickname
        END
    6: BEGIN
          ModifTickDef, 'Y'
          TicksChange,mainMenu,5,!y.tickname
        END
    7: BEGIN
          ModifInterval, 'X'
          Intervals, mainMenu, 6, !x.ticks
         END
    8: BEGIN
          ModifInterval, 'Y'
          Intervals, mainMenu, 7, !y.ticks
         END
    9: BEGIN
          ModifMarksNr, 'X'
          MinorTicksNr, mainMenu, 8, !x.minor
        END
    10: BEGIN
            ModifMarksNr, 'Y'
            MinorTicksNr, mainMenu, 9, !y.minor
          END
    11: BEGIN
            ModifStyle, 'X'
            AxisStyle, mainMenu, 10, !x.style
           END
    12: BEGIN
            ModifStyle, 'Y'
            AxisStyle, mainMenu, 11, !y.style
           END
    13: BEGIN
            IF !x.type EQ 1 THEN !x.type = 0 ELSE !x.type = 1
            AxisType, mainMenu, 12, !x.type
           END
    14: BEGIN
            IF !y.type EQ 1 THEN !y.type = 0 ELSE !y.type = 1
            AxisType, mainMenu, 13, !y.type
           END
    15: BEGIN
             Symbols, sName, /INTERACTIVE
             mainMenu(14) = StrMid( mainMenu(14), 0, 22 ) + sName
           END
     16: BEGIN
              IF !p.font EQ 0 THEN BEGIN
                Read_Test,'Please enter the character size ',1,charsize
                mainMenu(15) = 'Software Font, size '+StrTrim(charsize,2)
                !p.charsize = charsize
                !p.font = -1
              ENDIF ELSE BEGIN
                mainMenu(15) = 'Hardware Font'
                !p.font = 0
              ENDELSE
           END
     17: BEGIN
             lineChoice = General_Menu( ['Solid','Dotted','Dashed', $
	'Dash Dot', 'Dash Dot Dot Dot', 'Long Dashes'], $
	'Choose the overall line style')
             !p.linestyle = lineChoice-1
             LineStyle, mainMenu, 16, !p.linestyle
           END
     18: Data_Display
      ELSE:
  ENDCASE
END UNTIL choice EQ mainMenuLength

END       
          
