PRO AdjustTable,vectorTable, newLength

;+
; NAME:
; 	Adjust Table
; PURPOSE:
; 	Procedure to enlarge the length of a 2D table
;	in x direction.
; CALLING SEQUENCE:
;	AdjustTable, table, newLength
; INPUT PARAMETERS:
;	table: the 2D  table to adjust in x direction
; 	newLength: the integer length, greater as the former length
; OUTPUT PARAMETER:
;	table: the adjusted table.
;-
; MODIFICATION HISTORY:
;	Created in May 1991 by A.Csillaghy, 
;		Inst of Astronomy, ETH Zurich
;

  tableLength = N_Elements(vectorTable(0,*))
  newTable = Replicate( 0.0, newLength, tableLength )
  newTable(0,0) = vectorTable
  vectorTable = newTable

END ; Adjust  Table
