;+
; NAME:
;	Store_Text
; PURPOSE:
;	Stores a text in a table
; CATEGORY
;	Data Management
; CALLING SEQUENCE:
;	Store_Text, x, y, text, sizeText
; INPUTS:
;	x, y: the posittion of the thext on the window.
;	text: a string
;	sizeText: its size, relative to the value of !p.charsize.
; SIDE EFFECT:
;	The text table is changed
;-
; MODIFICATION HISTORY:
; 	Created by A.Csillaghy in July 1991
;		Inst. of Astronomy, ETH Zurich


PRO Store_Text, x, y, text, sizeText

COMMON TextRetrieval, textTable

IF N_Elements(textTable) EQ 0 THEN $
   textTable = { tableType, x: 0.0, y: 0.0, entry: 0, size: 1.0, text: ''}

p = {tableType}
p.x = x
p.y = y
p.text = text
p.size = sizeText

textTable = [ textTable, p ]

END