;
; $Id: color_palette.pro,v 1.2 90/02/13 17:29:03 steveg Exp $
;
pro color_palette,DELETE=delete
;+
; NAME:  
;	Color_Palette
; PURPOSE: 
;	To display the numerical values associated 
;	with a color table
; CATEGORY:
;	Image Processing
; KEYWORD:
;	DELETE: If set, the palette window is closed and the
;	procedure exited.
; COMMON BLOCKS:
; 	PaletteWindow, for keeping the number of the opened
;	window.
; SIDE EFFECTS:
;	A new window is opened
; RESTRICTIONS:
;	Works only on color stations
; MODIFICATION:
;	A.Csillaghy, April 1991
;-

COMMON PaletteWindow, paletteWinNr

IF Keyword_Set(DELETE) THEN BEGIN
  IF N_Elements(paletteWinNr) NE 0 THEN $
    IF paletteWinNr NE 999 THEN BEGIN
      WDelete, paletteWinNr
      paletteWinNr = 999
      RETURN
    ENDIF
ENDIF

; Find interval to be used on the table
int=1
if (!d.n_colors gt 128) then int=2
;
; Save currently active window number
holdw = !d.window
holdp = !p.color
;
; Set up window
yboxes=fix(!d.n_colors/(8*int))
yvalue=yboxes*8*int
if (yvalue ne !d.n_colors) then yboxes=yboxes+1
ysize=yboxes*40
paletteWinNr = !d.window+1
window,paletteWinNr,xsize=320,ysize=ysize

;
; Calculate when to switch printing the label in the opposite color
!p.color=!d.n_colors-1
change=yvalue*3/4
;
; Loop through colors 
x=0
y=0
for i=0,!d.n_colors-1,int do begin
   tv,replicate(i,40,40),x,y
   if (i ge change) then !p.color=0
   xyouts,x+5,y+5,strtrim(string(i),2),/device
   x=x+40
   if (x ge 40*8) then begin
      x=0
      y=y+40
   endif
endfor
;
; Set back to previously active window
if holdw ge 0 then wset,holdw
!p.color=holdp
;
; Finish
return
end

