PRO Display_1D

;+
; NAME:
;	Display_1D
; PURPOSE:
;	User interface to handle with a cpollection of plots
;	stored in the selection or given as arguments.
;	It assumes the selectioner is active.
; CATEGORY
;	User Interface
; CALLING SEQUENCE:
;	Display_1D
; SIDE EFFECTS:
;	Uses a lot of windows. Uses the selection data type.
; RESTRICTION:
;	Use only in interactive mode.
;-
;MODIFICATION HISTORY:
;	Created in April 1991 by A.Csillaghy


  IF N_Selected() LE 0 THEN RETURN

  mainMenuLength = 12
  mainMenu = StrArr(mainMenuLength)

  mainMenu(0) = 'Reset Zooms'
  mainMenu(1) = 'X Zoom ... '
  mainMenu(2) = 'Y Zoom ... '
  mainMenu(3) = 'Integration ...'
  mainMenu(4) = 'Read Values ... '
  mainMenu(5) = 'X Static Zoom  ... '
  mainMenu(6) = 'Y Static Zoom  ... '
  mainMenu(7) = 'Static Integration  ... '
  mainMenu(8) = 'Histogram of y-Values ... '
  mainMenu(9) = 'Make PostScript File / Print ... '
  mainMenu(10) = 'Return to Main Menu'
  mainMenu(11) = 'Redisplay this Menu '

  choice = 0

  GetTitles, title, xTitle, yTitle, subTitle
  !p.title = title & !x.title = xTitle & !y.title = yTitle 
  !p.subtitle = subTitle
  reset = 0

  REPEAT BEGIN 
  
    IF (choice LE 4)  OR  ((choice GE 6) AND (choice LE 8)) THEN $
	 Data_Display, RESET = reset, /MDISP

    reset = 0

    IF !d.name EQ 'X' THEN choice = General_Menu(mainMenu, $
	'Display: Choose Operation') $
    ELSE BEGIN
       choice = Keyboard_Select('<R>eset, <X> , <Y> Zoom, '+  $
	'<I>ntegrate, Read <V>alues,  <P>rint, <E>xit', $
	'Display:' )
      IF choice EQ 6 THEN choice = 10 $
      ELSE IF choice EQ 7 THEN choice = mainMenuLength-1
      IF (choice GE 2) AND (choice LE 4) THEN BEGIN
        newChoice = Keyboard_Select('<Y>es, <N>o', $
	'Dynamic Operation ? ')
        IF newChoice EQ 2 THEN choice = choice + 4 
      ENDIF
      IF choice EQ mainMenuLength-1 THEN $
        IF !d.name EQ 'TEK' THEN  EraseVT 
    ENDELSE
	

    CASE choice OF
      1: reset = 1
      2: Zoom_1D, 'X'
      3: Zoom_1D, 'Y'
      4: Integration, /MDISP
      5: Read_Values
      6: Zoom_1D, 'X',/STATIC
      7: Zoom_1D, 'Y',/STATIC
      8: Integration, /MDISP,  /STATIC
      9: HistoFacility
      10: BEGIN
            PrintInterface, status
            PS_Create_1D, /MDISP
            PrintInterface, status, /PRINT
          END
    ELSE:
    ENDCASE
  
  END UNTIL choice EQ mainMenuLength-1

END
