FUNCTION ElimBreaks, value,  min, max, length, breaks, pos, offset

;+
; PURPOSE:
;	Eliminate from "value" the "offset" 's due to displaying
;	non-homogeneous axes in the enrad system
;-

  nBreaks = N_Elements( breaks )
  IF nBreaks LE 2 THEN RETURN, value

  factor = Float( length ) / ( max - min + 1 )

  breakDev = pos  & holeDev = pos
  i = 1
  totalOffset = 0

  WHILE (value GT breakDev) AND (i LT nBreaks-1) DO BEGIN

    neighbour = (breaks(i) EQ breaks(i-1) + 1)
    IF  neighbour  THEN $
      totalOffset = totalOffset + offset

    breakDev = Round(breaks(i)*factor) + pos + totalOffset
    holeDev = breakDev - offset*neighbour
    i = i+1

  ENDWHILE

  inHole = value GE holeDev AND value LT breakDev

  RETURN, pos > ( value - totalOffset + offset*inHole ) < (length+pos)

END ; elimbreaks.pro

