PRO LoadUserSym, nb

; PURPOSE:
; 	Loads a predefined symbol for mdisp.
;	These are : X, Y, Z , 0 to 9

  COMMON Symbols, def, zeroX, zeroY, oneX, oneY, twoX, twoY, $
	threeX, threeY, fourX, fourY, fiveX, fiveY, $
	eightX, eightY, xX, xY, yX, yY

  IF N_Elements( def ) EQ 0 THEN BEGIN
    def = 1
    zeroX = [ 0, 1, 2, 3, 4, 5, 6, 5, 4, 3, 2, 1, 0, -1, -2, -3, -4, -5, -6, $
	 -5, -4, -3, -2 , -1, 0 ] / 4.
    zeroY = [ 11, 11, 10.5, 10, 9, 7, 0, -7, -9, -10, -10.5, -11, -11, $
	 -11, -10.5, -10, -9, -7, 0, 7, 9, 10, 10.5, 11, 11 ] / 4.
    oneX = ([ 1.2, 1.95, 1.95, 1.3, 2.6 ] - 1.95)*2
    oneY = ([ 3.5, 3.75, 1.1, 1.1, 1.1 ]- 2.425)*2
    twoX = ([1.3, 1.4, 1.6, 1.8, 2.0, 2.2, 2.4, 2.6, 2.4, 1.4, 2.6, 2.7] - 2)*2
    twoY = ([2.9, 3.4, 3.6, 3.7, 3.7, 3.6, 3.45, 3.0, 2.4, 1.1, 1.1, 1.5] - 2.4)*2
    threeX = [-6, -5, -4, -3, -2, -1, 0, 1,2,3,4,4,3,2,1,0,-3, 0, 1,2,3,$
	4,5,5,4,3,2,1,0,-1,-2,-3,-4,-5,-6,-7] /4. 
    threeY = [9,9.5,10,10.3, 10.5, 10.5, 10.2, 9.8, 9.5, 8.5, 7, 5,4,2,1,0,$
	0,0, $
	-0.2, -0.5, -1.5, -3, -5, -7, -9, -11, -11.4, -12, -12.5, $
	-13, -13, -12.5, -12, -12, -11.5, -11] /4.
    eightX = [0,1,2,3,4,5,5,4,3,2,1,0,-1,-2,-3,-4,-5,-6,-6,-5,-4,-3,-2,$
	-1,0,1,2,3,4,5,6,6,5,4,3,2,1,0,-1,-2,-3,-4,-5,-5,-4,-3, $
	-2,-1,0 ] /4.
     eightY = [11,11,10.5, 10, 9.5, 9, 4.5, 3.5, 2.5,1.5, 0.5, 0,0,-0.5, $
	-1,-1.5,-2,-4,-8,-9,-10,-11,-11.5, -12, -12, -12, $
	-11.5, -11, -10, -9, -8, -4, -2, -1.5, -1, -0.5, $
	0,0,0.5,1.5,2.5, 3.5, 4.5, 9, 9.5, 10, 10.5, 11,11] /4.
     xX = [0,1,0,-1,0,-1,0,1.0]
     xY = [0,1,0,1,0,-1.5,0,-1.5]
     yX = [-1,0,1,0,0.0]
     yY = [1,0,1,0,-1.5]
     fourX=[-5,5,0,0,-13,5]
     fourY=[-13,-13,-13,14,-5,-5]
     fiveX=[-9,-8,-5,-2,4,6,7.5,7,6.5,6,0,-6,-6,6]
     fiveY=[-5,-7,-10,-12,-10,-7,-5,-2,0,2,5,2,15,15]

  ENDIF

  CASE nb OF 
    0: UserSym, zeroX, zeroY
    1: UserSym, oneX, oneY
    2: UserSym, twoX, twoY
    3: UserSym, threeX, threeY
    4: UserSym, fourX, fourY
    5: UserSym, fiveX, fiveY
    8: UserSym, eightX, eightY
    11: UserSym, yX, yY
    12: UserSym, xX, xY
    ELSE: UserSym, zeroX, zeroY
  ENDCASE

END ; load user-defined symbol.