;
; $Id: wmesg.pro,v 1.2 1991/07/08 10:10:16 steveg Exp $
;
Function WMESG, strings, title, xpos, ypos, bgclr=bgclr, fgclr=fgclr, window=window

; NAME:		WMESG
; PURPOSE:	Output a window with text in it.

; check if foreground and background colors not set explicitly:
bgclrnset = 0
fgclrnset = 0
if n_elements(bgclr) eq 0 then begin  ; bg color not explicitly set
  bgclrnset = 1
  bgclr = !D.N_Colors - 1
endif
if n_elements(fgclr) eq 0 then begin  ; fg color not explicitly set
  fgclrnset = 1
  fgclr = 0
endif
if !d.n_colors eq 2 then begin
  bgclrnset = 0
  fgclrnset = 0
  bgclr = 1
  fgclr = 0 
endif

if !d.name eq 'SUN' then begin
  tmp=fgclr
  fgclr=bgclr
  bgclr=tmp
endif

if n_elements(title) eq 0 then title = 'Message'

char_mult = 1.2
yoffset = !D.Y_Ch_Size * char_mult * 0.3
linespacing = !D.Y_Ch_Size * char_mult + yoffset
;Width of window
wid = 10 + $
      (strlen(title) > max(strlen(strings))) * !D.X_Ch_Size * char_mult 
n = n_elements(strings)
ht = n * linespacing + yoffset

if n_elements(window) eq 0 then begin
   if ((n_elements(ypos) ne 0) and (n_elements(xpos) ne 0)) then begin
      window, /free, xpos = xpos, ypos = ypos, title=title, $
         xsiz = wid, ysiz = ht
   endif else begin
      window,/free, title=title, xpos = 0, ypos = 0, xsiz = wid, ysiz = ht
   endelse
endif else begin
   if !D.Window eq window then begin
      wset, window
   endif else begin
      if ((n_elements(ypos) ne 0) and (n_elements(xpos) ne 0)) then begin
         window, /free, xpos = xpos, ypos = ypos, title=title, $
            xsiz = wid, ysiz = ht
      endif else begin
         window,/free, title=title, xpos = 0, ypos = 0, xsiz = wid, ysiz = ht
      endelse
   endelse
endelse
   
if fgclrnset or bgclrnset then begin
  if (!d.n_colors eq 2) then begin
    strcolor = fgclr
    screenclr = fgclr
  endif else begin
    strcolor = fgclr
    screenclr = bgclr
  endelse
endif else begin
  strcolor = fgclr
  screenclr = bgclr
endelse

erase, screenclr
empty 

if (!d.n_colors eq 2) then begin
  if ((!d.name eq 'X') or (!d.name eq 'SUN')) then begin
    device,get_graph=save_func
    device,set_graph=6  
  endif
endif

for i=0,n-1 do begin
     xyouts, 5, (n-1-i) * linespacing + yoffset, $
	strings(i), /dev, /nocl, font=1, color=strcolor, size=char_mult
     empty
endfor

if (!d.n_colors eq 2) then begin
  if ((!d.name eq 'X') or (!d.name eq 'SUN')) then begin
    device, set_graph=save_func
  endif
endif

return, !D.Window
end
