FUNCTION Extract_Names, completeNames

;+
; NAME:
;	Extract_Names
; PURPOSE:
;	Returns a array of strings containing names WITHOUT
;	directory specifications.
; CATEGORY:
;	IO
; CALLING SEQUENCE
;	names = Extract_Names( completeNames )
; INPUT
;	completeNames: The name as got with "FindFile", a
;		string array
; OUTPUT:
;	names: The names without directory specification,
;		a string array.
;-
; MODIFICATION HISTORY:
;	Created by A.Csillaghy in June 1991
last = 0
REPEAT BEGIN
  oneBeforeLast = last
  last = StrPos( completeNames(0), '/',last+1)
END UNTIL last EQ -1
length = StrLen(completeNames)-oneBeforeLast+1
RETURN, StrMid(completeNames, oneBeforeLast+1,MAX(length))

END
