PRO QualifTransform, qual, lineStyle, userSym

;+
; NAME:
;	Qualifier Transformer
; PURPOSE: 
;	Decodes mdisp-file qualifiers in wave qualifiers and
;	linestyle and usersym values. Perhaps you find it a nonsense,
;	but this was done to match the qualifier of the old system,
;	ndisp, which was running on the VAX 780 long time ago ...
; CALLING SEQUENCE:
;	QualifTransform, qualifier, lineStyle, userSym
; INPUT:
;	qualifier: an array of qualifiers as read by the procedure
;		"mdispread" or "columns_read"
; OUTPUTS:
;	qualifier: the qualifiers according to the values of the
;		!psym symbol (array of integers);
;	lineStyle: the linestyle associated with the qualifier, 
;		according to the !p.linestyle values;
;		Format: array of integers (same dimension as
;		"qualifier")
;	userSym: the number of the user symbol. This value
;		can then be passed to the procedure 
;		"loadusersym" to plot user symbols. If 
;		"userSym" is not 0, the corresponding qualifier
;		value is 8.
;		Format: array of integers (same dimension as
;		"qualifier")
; MODIFICATION HISTORY:
;	Created, A.Csillaghy, ETHZ, Nov. 91
;	Modified, Csillaghy, Nov 92, for Wave 4 adaptation.
;-

  qual = Fix( qual )
  lineStyle = 0*qual
  userSym = 0*qual
  newQual = 0*qual

  FOR i = 0, 19 DO BEGIN  
    list = Where( qual EQ i ) 
    IF Total( list ) NE -1 THEN BEGIN 
      CASE 1 OF
        (i EQ 1):  newQual( list ) = 1 
        (i EQ 2):  newQual( list ) = 3
        (i EQ 3):  newQual( list ) = 2 
        (i LE 5 ):  newQual( list ) = i 
        (i LE 8) :  newQual( list ) = i-1 
        (i EQ 10): newQual( list ) = 10
        ELSE:
      ENDCASE
      qual( list ) = 9999
    ENDIF
  ENDFOR
  restList = Where( qual NE 9999 )
  WHILE Total( restList ) NE -1 DO BEGIN
    lineStyle( restList )  = (qual( restList ) / 20) - 2
    qual( restList ) =  qual( restList ) MOD 20 
    FOR i = 0, 19 DO BEGIN
      list = Where( qual EQ i )
      IF Total( list ) NE -1 THEN BEGIN
        CASE 1 OF
          ( i EQ 0 ) : newQual( list ) = 2
          ( i EQ 1 ) : newQual( list ) = 1
          ( i EQ 2 ) : BEGIN 
            newQual(list) = 8 
            userSym(list) = 10 
          END
          ( i EQ 3) : BEGIN 
            newQual( list ) = 8 
            userSym( list ) = 11
          END
          ( i EQ 4): BEGIN 
            newQual( list ) = 8
            userSym( list ) = 12
          END
          ( i LE 14) : BEGIN 
            userSym( list ) = qual( list ) -5 
            newQual( list ) = 8 
          END
          ( i LE 19): newQual( list ) = qual( list ) - 12
          ELSE: 
        ENDCASE
        qual( list ) = 9999
        newQual( list )  = (-1)^(lineStyle( list ) GE 0 ) * newQual( list )
        lineStyle( list ) = lineStyle( list ) > 0
      ENDIF
    ENDFOR
    restList = Where( qual NE 9999 )
  ENDWHILE

  qual = newQual

END ; Qualif transform