;+
; NAME:
;	Read VMS Record
; PURPOSE: 
;	Reads a VMS-format variable-length
;	record on the Unix system.
; CALLING SEQUENCE:
;	ReadVMSRec, unit, record
; INPUT PARAMETERS:
;	unit: The logical unit number of the (already opened) 
;		VMS-format file
; OUTPUT PARAMETERS:
;	record: The record read, an array of bytes.
; RESTRICTIONS
;	This procedure cannot be used for Unix files.
; MODIFICATION HISTORY:
;	Created by A.Csillaghy in September 1991
;		Inst. of Astronomy, ETH Zurich
;-


FUNCTION Odd, number

  RETURN, (number MOD 2) EQ 1 

END ; Odd


PRO ReadVMSRec, unit, record

  word = BytArr(2)
  ReadU, unit, word
  len = Fix( word, 0 )
  recLen = len + Odd(len)
  record = BytArr( recLen )
  ReadU, unit, record
  record = record(2:recLen-1-Odd(len) )
stop
END ; ReadVMSRec

