FUNCTION VMSFloat, numberByte

  sign = (numberByte(1) / 128) EQ 1
  exponent = (numberByte(1) MOD 128)*2 + $
	((numberByte(0)/128) EQ 1)
  mantissa = Long( numberByte(0) MOD 128 )*2L^16 + $
	Long( numberByte(3) )*2L^8 + Long( numberByte(2))

  exponent = exponent-128
  number = 0.5D & i=-24
  WHILE mantissa NE 0 DO BEGIN
    number = number + (mantissa MOD 2)*2D^i
    mantissa = mantissa/2 & i=i+1
  ENDWHILE

  number = (-1)^(sign)*number*2^exponent
  RETURN, Float(number)

END ; VMS Float

  
FUNCTION Odd, number

  RETURN, (number MOD 2) EQ 1 

END ; Odd


PRO ReadVMSRec, unit, record

  word = BytArr(2)
  ReadU, unit, word
  len = Fix( word, 0 )
  recLen = len + Odd(len)
  record = BytArr( recLen )
  ReadU, unit, record
  record = record(2:recLen-1-Odd(len) )

END ; ReadVMSRec


PRO Sca_Read_VMS, filename, z, x, y, $
	TITLE = title, NAME = name, $
	XLAB = xLab, YLAB = yLab, ZLAB = zLab

OpenR, unit, filename, /GET_LUN
word = BytArr(2)
first = 1
; read titles

WHILE NOT EOF(unit) DO BEGIN

  ReadVMSRec, unit, rawData
  IF first THEN BEGIN
    data = rawData 
    first = 0
  ENDIF ELSE data =  [ data, rawData ]

ENDWHILE

title = String(data(0:79) )
xLab = String( data(80:99) )
yLab = String( data(100: 119) )
zLab = String( data(120:139) )
name = String( data( 140:148 ) )

nx = Fix( data(IndGen(4)+149), 0 )
ny = Fix( data(IndGen(4)+153), 0 )
x0 = VMSFloat( data(IndGen(4) + 157 ))
y0 = VMSFloat( data(IndGen(4) + 161 ))
dx = VMSFloat( data(IndGen(4) + 165 ))
dy  = VMSFloat( data(IndGen(4) + 169 ))

z = FltArr( nx, ny )
arrMax = Long(nx)*Long(ny)-1L
FOR i = 0L, arrMax DO BEGIN
  index = i*4 + 173L
  z(i) = VMSFloat( data(index:index+3) )
ENDFOR

x = IndGen(nx)*dx + x0
y = IndGen(ny)*dy + y0

END
