FUNCTION DecConvert, str

;+
; CALLING SEQUENCE:
;	result = DecConvert( string )
; PURPOSE:
;	Converts string formatted as 'hh:mm:ss.dd' in
;	decimal format.
; INPUT:
;	string:  "hours:minutes:seconds.decimals" format
; OUTPUT:
;	result of function: the FLOAT number
; SIDE EFFECT:
;	If the string given is not of the correct format, an INTEGER
;	with value 0 is returned.
; MODIFICATION HISTORY: 
;	Created by A.Csillaghy in October 1991
;		Inst. of Astronomy, ETH Zurich
;-

  hours = StrMid( str, 0, 2 )
  minutes = StrMid( str, 3, 2 )
  seconds =  StrMid( str, 6, StrLen(str)-6 )

  IF NOT ( IsDigit( hours ) AND IsDigit( minutes ) AND $
	IsDigit( seconds ) )  THEN RETURN,  0

  RETURN, Double(hours)*3600 + $
	Float( minutes )*60 + $
	Float( seconds )

END ; decimal conversion