FUNCTION GetWNr

;+
; NAME
; 	Get Window Number
; PURPOSE:
; 	checks for the number of the window in which to
;       display the next data set
; OUTPUT:
; 	Then window number
; RESTRICTIONS
; 	Works in the framework of the window manager of RAGView.
;	The procedure Init_Selection must be called first! 
; AUTHOR:
; 	A. Csillaghy, csillag@astro.phys.ethz.ch
;-
   
  COMMON Selection2D, d1, wNr, d2, nbWMax, dir

  IF N_Elements( wNr ) EQ 0 THEN BEGIN
    wNr = -1 & nbWMax = 4
  ENDIF
  IF !d.window EQ - 1 THEN wNr = -1

  wNr = (wNr + 1) MOD nbWMax

  RETURN, wNr 

END ; GetWNr

