FUNCTION IsDigit,string

;+
; NAME:
;	Is Digit
; PURPOSE:
;	Tests if a string is the ASCII representation of a number
;	or not
; CALLING SEQUENCE:
;	result = IsDigit( string )
; INPUT PARAMETER:
;	string:	the string to test.
; RESULT OF FUNCTION:
;	1 if the test is ok, 0 else.
; RESTRICTIONS:
;	Some cases are not well handled. For example, 3-4 or E45
;	are considered as string. In fact, the procedure tests only if
;	the string is composed with 0,1,2,...9, '.', '-', 'e' or 'E' 
;	characters.
; MODIFICATION HISTORY:
;	Created in May 91 by A.Csillaghy, ETHZ
;-

 n = StrLen( string )
 digit = 1

 FOR i=0,n-1 DO BEGIN
   char = StrMid( string, i,1 )
   digit = digit*( (char EQ '.') OR (char EQ '0') OR (char EQ '1') OR $
 	(char EQ '2') OR (char EQ '3') OR (char EQ '4') OR $
	(char EQ '5') OR (char EQ '6') OR (char EQ '7') OR $
	(char EQ '8') OR (char EQ '9') OR $ 
	(StrUpcase(char) EQ 'E') OR (char EQ '-') )
  ENDFOR
  RETURN, digit

END
