; x_tvmenu.pro:  a modified version of tvmenu.pro which more 
;    effectively controls menu background and foreground colors in 
;    X environments; also works in SunView environment.
; $Id: x_tvmenu.pro,v 1.1 1991/07/22 16:52:54 jeffry Exp $

; Author:  Mary Verkade, PVI
; Date:    15 July 1991

pro dummy_wind, x_ch_size, y_ch_size
if !D.NAME eq 'X' then $
   window,/free,xsize=2,ysize=2 $
else $
   window,/free,xsize=2,ysize=2,colors=128 
x_ch_size = !d.x_ch_size
y_ch_size = !d.y_ch_size
wdelete
end
;
;
Function x_tvmenu, strings, title, xpos, ypos, prev_ans = prev_ans

; NAME:		X_TVMENU
; PURPOSE:	Modify the PV-Wave User Library procedure TVMENU for
;               visibility of options in X-Window environments; works
;               also for SunViews environment (M.Verkade, 7-15-91)

dummy_wind, x_ch_size, y_ch_size

linespacing = fix(y_ch_size * 1.5)
yoffset = 8
if n_elements(title) eq 0 then title = 'Menu'

; set default for previous answer.  If parameter doesn't exist, set to 0
if n_elements(prev_ans) eq 0 then prev_ans = 0 

; Compute width of the window.  The window must be wide enough to hold the
; longest string, whether that is a normal string, or the title.  The 
; larger font of the title, and the DECWindows icon/widgets in the window
; label area must be taken into effect.  Computations for systems other
; than X-Windows are straightforward.

title_len      = strlen(title)          ; length of title
max_str_len    = max(strlen(strings))   ; lenght of longest string

n = n_elements(strings)
if (prev_ans gt n or prev_ans lt 0) then prev_ans = 0  ; check for bogus values
ht = n * linespacing + yoffset - 8
if n_elements(xpos) ne 0 then xpos_loc = xpos else xpos_loc = 0
if n_elements(ypos) ne 0 then ypos_loc = ypos else ypos_loc = 0

copy_col = 0
clear_col = 255
viz_col = 255

tvlct,curr_r,curr_g,curr_b,/get
tvlct,0,0,0,0
tvlct,255,255,255,!d.n_colors-1

if !D.NAME eq 'X' then begin
   absTitleLen = title_len* (2 * x_ch_size) + 10
   absMaxStrLen = max_str_len*x_ch_size + 20
   if  absTitleLen ge absMaxStrLen then $
      wid = 10 + absTitleLen $
   else wid = 20 + absMaxStrLen
   offwind = 0 - ypos_loc 
   if offwind gt -30 then $
      ypos_loc = ypos_loc + offwind + 30 $
   else $ 
      ypos_loc = ypos_loc + 30 
   window,/free,/pixmap,xpos=xpos_loc,ypos=ypos_loc,title=title, $
          xsiz = wid, ysiz = ht 
   copy_wind = !d.window
   erase,copy_col
   window,/free,/pixmap,xpos=xpos_loc,ypos=ypos_loc,title=title, $
          xsiz = wid, ysiz = ht 
   clear_wind = !d.window
   erase,clear_col
   window,/free,xpos=xpos_loc,ypos=ypos_loc,title=title, xsiz = wid, ysiz = ht 
   viz_wind = !d.window
   erase,clear_col
endif else begin
   wid = 10 + (title_len > max_str_len) * x_ch_size 
   copy_col = 0
   clear_col = 127
   viz_col = 127
   window,/free,xpos=xpos_loc,ypos=ypos_loc,title=title,xsiz=wid,ysiz=ht, $
          colors=128 
   copy_wind = !d.window
   erase,copy_col
   window,/free,xpos=xpos_loc,ypos=ypos_loc,title=title,xsiz=wid,ysiz=ht, $
          colors=128 
   clear_wind = !d.window
   erase,clear_col
   window,/free,xpos=xpos_loc,ypos=ypos_loc,title=title,xsiz=wid,ysiz=ht, $
          colors=128 
   viz_wind = !d.window
   erase,clear_col
endelse

wset, copy_wind
for i=0,n-1 do $	;Output text
     xyouts, 5, (n-1-i) * linespacing + yoffset/2, $
	strings(i),/dev,/nocl,font=0, color=clear_col
wset, clear_wind
for i=0,n-1 do $	;Output text
     xyouts, 5, (n-1-i) * linespacing + yoffset/2, $
	strings(i),/dev,/nocl,font=0, color=copy_col
wset, viz_wind
for i=0,n-1 do $	;Output text
     xyouts, 5, (n-1-i) * linespacing + yoffset/2, $
	strings(i),/dev,/nocl,font=0, color=copy_col

old_choice = prev_ans		;Prev choice = none
;Position cursor at previous position.
tvcrs,!d.x_size/2, ht - (prev_ans+1/2.)*linespacing  
iflag = 0
x1 = wid-1

ytop = intarr(n)
ybottom = intarr(n)
for i=0,n-1 do begin
   ytop(i) = (n - i) * linespacing + yoffset/2 - 4
   ybottom(i) = ytop(i) - linespacing - 4
endfor

y1 = linespacing + yoffset/2			
y0 = ybottom(old_choice) 		
device,copy=[0,y0,x1,y1,0,y0,copy_wind]

repeat begin
   tvrdc,xloc,yloc,iflag,/dev	;Get cursor after movement
   iflag = 2		;Next time wait
   if (yloc ge 0) then begin	;Hit?
      i = n - (fix(yloc / linespacing) + 1)

      if (i ne old_choice) then begin
         y0 = ybottom(i)
         device,copy=[0,y0,x1,y1,0,y0,copy_wind]
         y0 = ybottom(old_choice) 				; bottom
         device,copy=[0,y0,x1,y1,0,y0,clear_wind]
         old_choice = i		;New choice, invert area
      endif
    endif		;Y ge 0
endrep until !err ne 0
wdelete, copy_wind
wdelete, clear_wind
tvlct,curr_r,curr_g,curr_b
wdelete, viz_wind
return, i
end
