PRO ClickLimits, low, high, YDIR = yDir, TITLE = title

;+
; NAME:
;	Click the Limits
; PURPOSE: 
;	Interface to read maximum and minimum of a range from
;	points clicked with the mouse.
; CALLING SEQUENCE:
;	ClickLimits, low, high
; OUTPUT PARAMETERS:
;	low, high: the two limits in the coordinate system 	
;	established.
; KEYWORDS:
;	/YDIR: If present, the y coordinates are read, otherwise
;		the x coordinates.
;	TITLE: the name of the window containing the title.
; SIDE EFFECTS
;	Uses the x windows system
;-
; MODIFICATION HISTORY:
;	Created by A.Csillaghy in January 1992
;		Inst. of Astronomy, ETH Zurich


  IF Keyword_Set( YDIR ) THEN direction = 'Y' ELSE direction = 'X'
  IF NOT Keyword_Set( TITLE ) THEN title = ''

  IF !d.name EQ 'X' THEN BEGIN
    plotWin = !d.window
    msgWinNr = WMesg('Click on the new lowest ' + $
	direction + 'point  ', title, 200, 500 )
    WSet, plotWin
    Cursor, xLow, yLow, /UP
    WDelete, msgWinNr
    msgWinNr = WMesg('Click on the new highest ' + direction + $
	'point  ', title, 200, 500 )
    WSet, plotWin
    Cursor, xHigh, yHigh, /UP
    WDelete, msgWinNr
  ENDIF ELSE BEGIN
    Print, $
         'Move the cursor to the new lowest ' + direction + $
	'-point and press <return>'
    Cursor, xLow, yLow
    Print, $
          'Move the cursor to the new highest ' + direction + $
	'-point and press <return>....'
    Cursor, xHigh, yHigh
  ENDELSE

  IF direction EQ 'X' THEN BEGIN
    low = xLow & high = xHigh
  ENDIF ELSE BEGIN
    low = yLow & high = yHigh
  ENDELSE

  IF low GT high THEN BEGIN
    tmp = low & low = high & high = tmp
  ENDIF

END ; click the limits
