PRO Log_Plot

;+
; NAME
; 	 Log_Plot
; PURPOSE
;	Computes operations from the type
;		y = a Log( b* y + c ) + d
;	The user introduces on the keyboard
; 	the constants a, b, c and d. This procedure
;	is a part of the mdisp analyser.
;	The operation is performed only on selected plots
; CATEGORY:
;	1D
; CALLING SEQUENCE:
;	Log_Plot
; COMMON BLOCK:
;	ExpRetrieval: for intern use only
; SIDE EFFECTS:
;	The Selectioner of mdisp is used, and a new plot is
;	created.
; RESTRICTION:
;	To use ONLY together with the mdisp selectioner.
; -
; MODIFICATION HISTORY
;	Created: June 91, A.Csillaghy


COMMON LogRetr, logNr

IF N_Elements(logNr) EQ 0 THEN logNr= 0B
nbSel = N_Selected()

Clear_Screen
Print,'Logaritmization: y = a*ln(b*y+c) + d'
Read_Test,'Please enter the factor a: ',1.0, a
Read_Test, 'Please enter the factor b: ',1.0 ,b
Read_Test,'Please enter the factor c: ',0.0,c
Read_Test,'Please enter the factor d: ',0.0, d

FOR i = 1,nbSel DO BEGIN
  name = Selection(i)
  Load_Plot, name, x,y

  newY = a*Alog(b*y+c) + d
  newName = name + '_ln'+StrTrim(logNr,2)
  logNr = logNr +1 

  Store_Plot, newName, x,newY
  Remove_Sel, name
  Insert_Sel, newName

ENDFOR

END